#ifndef WDNS_CONSTANTS_H
#define WDNS_CONSTANTS_H

#define WDNS_LEN_HEADER		12
#define WDNS_MAXLEN_NAME	255

#define WDNS_MSG_SEC_QUESTION	0
#define WDNS_MSG_SEC_ANSWER	1
#define WDNS_MSG_SEC_AUTHORITY	2
#define WDNS_MSG_SEC_ADDITIONAL	3
#define WDNS_MSG_SEC_MAX	4

#define WDNS_PRESLEN_NAME	1025
#define WDNS_PRESLEN_TYPE_A	16
#define WDNS_PRESLEN_TYPE_AAAA	46

#define WDNS_OP_QUERY		0
#define WDNS_OP_IQUERY		1
#define WDNS_OP_STATUS		2
#define WDNS_OP_NOTIFY		4
#define WDNS_OP_UPDATE		5

#define WDNS_R_NOERROR		0
#define WDNS_R_FORMERR		1
#define WDNS_R_SERVFAIL		2
#define WDNS_R_NXDOMAIN		3
#define WDNS_R_NOTIMP		4
#define WDNS_R_REFUSED		5
#define WDNS_R_YXDOMAIN		6
#define WDNS_R_YXRRSET		7
#define WDNS_R_NXRRSET		8
#define WDNS_R_NOTAUTH		9
#define WDNS_R_NOTZONE		10
#define WDNS_R_BADVERS		16

#define WDNS_CLASS_IN		1
#define WDNS_CLASS_CH		3
#define WDNS_CLASS_HS		4
#define WDNS_CLASS_NONE		254
#define WDNS_CLASS_ANY		255

#define WDNS_TYPE_A		1
#define WDNS_TYPE_NS		2
#define WDNS_TYPE_MD		3
#define WDNS_TYPE_MF		4
#define WDNS_TYPE_CNAME		5
#define WDNS_TYPE_SOA		6
#define WDNS_TYPE_MB		7
#define WDNS_TYPE_MG		8
#define WDNS_TYPE_MR		9
#define WDNS_TYPE_NULL		10
#define WDNS_TYPE_WKS		11
#define WDNS_TYPE_PTR		12
#define WDNS_TYPE_HINFO		13
#define WDNS_TYPE_MINFO		14
#define WDNS_TYPE_MX		15
#define WDNS_TYPE_TXT		16
#define WDNS_TYPE_RP		17
#define WDNS_TYPE_AFSDB		18
#define WDNS_TYPE_X25		19
#define WDNS_TYPE_ISDN		20
#define WDNS_TYPE_RT		21
#define WDNS_TYPE_NSAP		22
#define WDNS_TYPE_NSAP_PTR	23
#define WDNS_TYPE_SIG		24
#define WDNS_TYPE_KEY		25
#define WDNS_TYPE_PX		26
#define WDNS_TYPE_GPOS		27
#define WDNS_TYPE_AAAA		28
#define WDNS_TYPE_LOC		29
#define WDNS_TYPE_NXT		30
#define WDNS_TYPE_EID		31
#define WDNS_TYPE_NIMLOC	32
#define WDNS_TYPE_SRV		33
#define WDNS_TYPE_ATMA		34
#define WDNS_TYPE_NAPTR		35
#define WDNS_TYPE_KX		36
#define WDNS_TYPE_CERT		37
#define WDNS_TYPE_A6		38
#define WDNS_TYPE_DNAME		39
#define WDNS_TYPE_SINK		40
#define WDNS_TYPE_OPT		41
#define WDNS_TYPE_APL		42
#define WDNS_TYPE_DS		43
#define WDNS_TYPE_SSHFP		44
#define WDNS_TYPE_IPSECKEY	45
#define WDNS_TYPE_RRSIG		46
#define WDNS_TYPE_NSEC		47
#define WDNS_TYPE_DNSKEY	48
#define WDNS_TYPE_DHCID		49
#define WDNS_TYPE_NSEC3		50
#define WDNS_TYPE_NSEC3PARAM	51
#define WDNS_TYPE_HIP		55
#define WDNS_TYPE_NINFO		56
#define WDNS_TYPE_RKEY		57
#define WDNS_TYPE_SPF		99
#define WDNS_TYPE_TKEY		249
#define WDNS_TYPE_TSIG		250
#define WDNS_TYPE_IXFR		251
#define WDNS_TYPE_AXFR		252
#define WDNS_TYPE_MAILB		253
#define WDNS_TYPE_MAILA		254
#define WDNS_TYPE_ANY		255
#define WDNS_TYPE_TA		32768
#define WDNS_TYPE_DLV		32769

#endif /* WDNS_CONSTANTS_H */
